  org 100h ; assume ah=0 cx=0xff si=0x100 [0xfd..ff]=0

  push 0xa000
  pop es
  mov al,13h
  int 10h     ; 320x200
  lds bp,[si-3]; bp=0 ds=6800h

M:
; Convert pixel address to X,Y
  cwd         ; dx=0
  mov ax,di
  mov bx,320
  div bx      ; dx = X(0..319) = adr%320
              ; ax = Y(0..200) = adr/320

; Plasma
  xlat
  cbw
X imul bx,ax,7
;  ds
Z sub al,[bx]  ; <- modified
;f7 db
  neg bx          ; can be assimilated into the ^add^
  xchg ax,dx
;  js X
  jnle X

  sub al,[bx+di]
  add al,dl
  js T
  not al
T shr al,3  ; /\/\ triangle 16..31..16
  stosb

; Cosine table: harmonic oscillator
; init: cx=C=255, si=S=256
  mov ax,24
  mov [di],ch ; cos[adr] = C/256
  add cx,si   ; C += S
  imul cx
  sub si,dx   ; S -= C/3276.8

  mov ah,7
  and ax,sp
  dec bp
  jnz M
  hlt         ; bp=0
  mov [bp+Z+1],ah  ; add al,[{bx+si bx+di bp+si bp+di si di 0xdbf7 bx}]
  call M ; sp-=2
