  org 100h ; assume ah=0 cx=0xff si=0x100 [0xfd..ff]=0

;c5 24
  lds bp,[si] ; bp=0x24c5 ds=0x6d2c
;2c 6d
  sub al,0x6d ; al=0x93
  push 0xa000
  pop es
  int 10h     ; 320x200

M:
; Convert pixel address to X,Y
  cwd         ; dx=0
  mov ax,di
  mov bx,320
  div bx      ; dx = X(0..319) = adr % 320
              ; ax = Y(0..200) = adr / 320

; Plasma
  xlat
  cbw
X imul bx,ax,7
C sub al,[bx] ;<- changed
;f7 db
  neg bx      ; can be assimilated into "sub"
  xchg ax,dx
  jg X

  sub al,[bx+di]
  add al,dl
  js T
  not al      ; 0..255 -> 255..128,128..255
T shr al,3    ; -> 31..16,16..31
  stosb

; Cosine table: harmonic oscillator
; init: cx=C=255, si=S=256
  mov ax,24
  mov [di],ch ; cos[adr] = C/256
  add cx,si   ; C += S
  imul cx
  sub si,dx   ; S -= C/3276.8

;  mov ah,7
;  and ax,sp
  imul ax,sp,-1
  inc bp
  jnz M
              ; bp=0
  hlt
  push dx
  mov [bp+C+1],ah  ; "sub al,[{bx+si bx+di bp+si bp+di si di 0xdbf7 bx}]"
  jmp M ; sp+=2
