  org 100h ; assume ah=0 cx=0xff si=0x100 [0xfd..ff]=0 cs<=0x5d2c

;  les bp,[bx]
  push 0xa000
  pop es
  mov al,13h
  int 10h     ; 320x200
  lds bp,[si-3]; bp=0 ds=0x6800
;  lds bp,[si-2]; bp=0 ds=0x6800

;;c5 2c
;  lds bp,[si] ; bp=0x2cc5 ds=0x6d2c
;;2c 6d
;  sub al,0x6d ; al=0x93
;  int 10h     ; 320x200
;  push 0xa000
;  pop es
;;  pop bp

M:
; Convert pixel address to X,Y
;  cwd         ; dx=0
  xor dx,dx
  mov ax,di
  mov bx,320
  dec bp
  jnz D
              ; bp=0 di=T
  hlt
  mov [bp+C+1],ah  ; "sub al,[{bx+si bx+di bp+si bp+di si di 0xdbf7 bx}]"
;  mov [byte ss:bx-320+C+1],ah  ; "sub al,[{bx+si bx+di bp+si bp+di si di 0xdbf7 bx}]"
  scasw       ; di+=2

D div bx      ; dx = X(0..319) = adr % 320
              ; ax = Y(0..200) = adr / 320
; Plasma
  xlat
  cbw
X imul bx,ax,7
;  ds
C sub al,[bx] ;<- changed
;f7 db
  neg bx      ; can be assimilated into "sub"
  xchg ax,dx
  jg X  ; for imul +7
  
  add al,dl
  sub al,[bx+di]
  js T
  not al      ; 0..255 -> 255..128,128..255
T shr al,3    ; -> 31..16,16..31
  stosb

; Cosine table: harmonic oscillator
; init: cx=C=255, si=S=256
  mov ax,24
  mov [di],ch ; cos[adr] = C/256
  add cx,si   ; C += S
  imul cx
  sub si,dx   ; S -= C/3276.8

  jmp M
