  org 100h ; assume ax=0 cx=0xff si=0x100 [0xfffe]=0 cs<=0x5d2c

;c5 2c
  lds bp,[si] ; bp=0x2cc5 ds=0x6d2c
;2c 6d
  sub al,0x6d ; al=0x93: 320x200 mode without clearing the screen
  pop bp      ; bp=0

;  push 0xa000
;  pop es
;  lds bp,[si-3]; bp=0 ds=0x6800

; Start of overlap
;b0 13
;  mov al,0x13
;cd
  db 0xcd     ; init: cd 10     int 10h   ; set 320x200
              ;       d0 2a     shr byte[bp+si],1
              ;       01 78 02  add [bx+si+2],di


;10 d0        ; later: 13 cd  adc cx,bp
M:db 0x10,0xd0;        10 d0  adc al,dl (we need this variant)
;2a 01
  sub al,[bx+di]
;78 02
  js T
; End of overlap

  not ax      ; 0..255 -> 255..128,128..255
T shr al,3    ; -> 31..16,16..31
  stosb

; Cosine table: harmonic oscillator
; init: cx=C=255, si=S=256
  mov [di],ch ; cos[adr] = C/256
  add cx,si   ; C += S
  mov ax,24
  imul cx
  sub si,dx   ; S -= C/3276.8

; Convert pixel address to X,Y
  xor dx,dx
  mov ax,di
  mov bx,320
  inc bp      ; on init: di goes from -2 up to 0xd339 = -0x2cc7
;  jnz D
  jnz D-1
              ; bp=0 ax=di=T(0xd339, 0xd33b, ..., 0xd401, ...)
  hlt
  scasw       ; di+=2
;  mov [bp+C+1],ah  ; sub dl,bl (0xd3), sub dl,ah (0xd4), ...

;36 88 67 f7  ; mov [ss:bx-9],ah
  mov [byte ss:bx-320+C+1],ah  ; "sub al,[{bx+si bx+di bp+si bp+di si di 0xdbf7 bx}]"

;f7 fb        ; idiv bx
;   fb        ; sti
D sti
;D idiv bx     ; dx = X(0..319) = adr % 320
              ; ax = Y(0..200) = adr / 320
 
; Plasma
  push 0xa000
  xlat
  cbw
X imul bx,ax,5
  
C add al,[bx+si] ;<- changed to: sub dl,bl (0xd3), sub dl,ah (0xd4), ...
  
;f7 db
  neg bx      ;<- can be a part of the "sub"
  xchg ax,dx
  jg X

  pop es
  jmp M
